import _objectSpread from "@babel/runtime/helpers/objectSpread";
import 'colors';
import { measureFunc, measureMethod } from './measure';

var _require = require('marky'),
    _mark = _require.mark,
    _stop = _require.stop,
    _getEntries = _require.getEntries;

if (process.env.NODE_ENV === 'production') {
  console.warn('Perf monitoring is not recommendend in production builds.'.yellow); //eslint-disable-line
}

export default (function (namespace) {
  var prefix = "(" + namespace + ")";
  var perf = {
    mark: function mark(label) {
      return _mark(prefix + label);
    },
    stop: function stop(label) {
      return _stop(prefix + label);
    },
    getEntries: function getEntries() {
      return _getEntries().map(function (entry) {
        var name = entry.name;

        if (name.indexOf(prefix) === 0) {
          return _objectSpread({}, entry, {
            name: name.replace(prefix, '')
          });
        }
      }).filter(Boolean);
    }
  };
  perf.measure = measureFunc(perf);
  perf.measureMethod = measureMethod(perf);
  return perf;
});