import ReactDebug from 'react-dom/lib/ReactDebugTool';
import ReactComponentTreeHook from 'react/lib/ReactComponentTreeHook';

var SuiPerfHook =
/*#__PURE__*/
function () {
  function SuiPerfHook(perf) {
    this.perf = perf;
  }

  var _proto = SuiPerfHook.prototype;

  _proto.isNativeComponent = function isNativeComponent(debugID) {
    var label = ReactComponentTreeHook.getDisplayName(debugID) || 'unknown';
    return label[0].toLowerCase() === label[0];
  };

  _proto.getMarkName = function getMarkName(debugID) {
    return '<' + (ReactComponentTreeHook.getDisplayName(debugID) || 'Unknown') + '>';
  };

  _proto.onBeforeMountComponent = function onBeforeMountComponent(debugID, element, parentDebugID) {
    !this.isNativeComponent(debugID) && this.perf.mark(this.getMarkName(debugID));
  };

  _proto.onMountComponent = function onMountComponent(debugID, element, parentDebugID) {
    !this.isNativeComponent(debugID) && this.perf.stop(this.getMarkName(debugID));
  };

  return SuiPerfHook;
}();

var measureReact = function measureReact(perf) {
  var perfHook = new SuiPerfHook(perf);
  ReactDebug.addHook(perfHook);
  return ReactDebug.removeHook.bind(ReactDebug, perfHook);
};

export default measureReact;