export var measureFunc = function measureFunc(_ref) {
  var mark = _ref.mark,
      stop = _ref.stop;
  return function (label) {
    return function (func) {
      if (func.__isBeingMeasured__) {
        return;
      } else {
        func.__isBeingMeasured__ = true;
      }

      mark(label);
      var result = func();

      var stopMeasure = function stopMeasure() {
        return stop(label);
      };

      result instanceof Promise ? result.then(stopMeasure, stopMeasure) : stopMeasure();
      return result;
    };
  };
};
export var measureMethod = function measureMethod(perf) {
  var measure = measureFunc(perf);
  return function (label) {
    return function (obj, methodName) {
      var originalMethod = obj[methodName];

      obj[methodName] = function () {
        var _this = this;

        for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
          args[_key] = arguments[_key];
        }

        var labelText = typeof label === 'function' && label.call.apply(label, [this].concat(args)) || label || methodName;
        return measure(labelText)(function () {
          return originalMethod.call.apply(originalMethod, [_this].concat(args));
        });
      };
    };
  };
};